<template>
  <transition
    enter-active-class="transition-opacity duration-75"
    enter-from-class="opacity-0"
    enter-to-class="opacity-100"
    leave-active-class="transition-opacity duration-150"
    leave-from-class="opacity-100"
    leave-to-class="opacity-0"
  >
    <div
      class="flex items-start gap-4 p-4 my-4 text-sm text-yellow-700 bg-yellow-100 rounded-lg dark:bg-mbz-yellow dark:text-yellow-800"
      role="alert"
      v-show="showSuggestion"
    >
      <div class="flex flex-wrap justify-center">
        <p
          class="text-base"
          v-html="
            $gettext(
              'If you already have a Mobilizon account somewhere, %{indexName} can redirect you to your own instance to interact with events and groups.',
              { indexName },
              true
            )
          "
        />
        <button
          class="px-5 py-3 font-medium text-white bg-yellow-700 rounded"
          @click="setIsOpen(true)"
        >
          {{ $gettext('Set my instance') }}
        </button>
      </div>
      <button
        class="hidden md:block opacity-90"
        type="button"
        @click="dismissSuggestion"
      >
        <span class="sr-only">{{ $gettext('Close') }}</span>

        <svg
          class="w-4 h-4"
          xmlns="http://www.w3.org/2000/svg"
          viewBox="0 0 20 20"
          fill="currentColor"
        >
          <path
            fill-rule="evenodd"
            d="M4.293 4.293a1 1 0 011.414 0L10 8.586l4.293-4.293a1 1 0 111.414 1.414L11.414 10l4.293 4.293a1 1 0 01-1.414 1.414L10 11.414l-4.293 4.293a1 1 0 01-1.414-1.414L8.586 10 4.293 5.707a1 1 0 010-1.414z"
            clip-rule="evenodd"
          />
        </svg>
      </button>
    </div>
  </transition>
  <TransitionRoot
    :show="isOpen"
    as="template"
    enter="duration-300 ease-out"
    enter-from="opacity-0"
    enter-to="opacity-100"
    leave="duration-200 ease-in"
    leave-from="opacity-100"
    leave-to="opacity-0"
  >
    <Dialog
      :open="isOpen"
      @close="setIsOpen"
      class="text-gray-900 dark:text-slate-100 relative z-50"
    >
      <div class="fixed inset-0 bg-black/40" aria-hidden="true" />
      <div class="fixed inset-0 flex items-center justify-center p-4">
        <DialogPanel
          class="w-full max-w-sm rounded dark:bg-zinc-900 bg-white p-6"
        >
          <DialogTitle>{{ $gettext('Set my instance') }}</DialogTitle>
          <DialogDescription>
            <div class="mb-3">
              <label
                for="federated-identity-picker"
                class="block mb-2 text-sm font-medium text-gray-900 dark:text-gray-300"
                >{{ $gettext('Your federated identity') }}</label
              >
              <input
                type="email"
                id="federated-identity-picker"
                class="bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg focus:ring-blue-500 focus:border-blue-500 block w-full p-2.5 dark:bg-gray-700 dark:border-gray-600 dark:placeholder-gray-400 dark:text-white dark:focus:ring-blue-500 dark:focus:border-blue-500"
                placeholder="me@mobilizon.fr"
                required
                :value="federatedUsername"
                @input="onInput"
              />
            </div>
          </DialogDescription>

          <div
            class="block p-3 mb-3 bg-gray-900 border border-gray-800 shadow-xl rounded-xl"
            v-if="instance"
          >
            <h3 class="mt-1 text-xl font-bold text-white">
              {{ instance.name }}
            </h3>
            <span class="text-sm text-gray-300">{{ instance.host }}</span>
            <p class="mt-2 text-sm text-gray-300">{{ instance.description }}</p>
          </div>

          <button
            class="text-gray-900 hover:text-white border border-gray-800 hover:bg-gray-900 focus:ring-4 focus:outline-none focus:ring-gray-300 font-medium rounded-lg text-sm px-5 py-2.5 text-center mr-2 mb-2 dark:border-gray-600 dark:text-gray-400 dark:hover:text-white dark:hover:bg-gray-600 dark:focus:ring-gray-800"
            @click="setIsOpen(false)"
          >
            {{ $gettext('Cancel') }}
          </button>
          <button
            class="text-white bg-blue-700 hover:bg-blue-800 focus:ring-4 focus:ring-blue-300 font-medium rounded-lg text-sm px-5 py-2.5 mr-2 mb-2 dark:bg-blue-600 dark:hover:bg-blue-700 focus:outline-none dark:focus:ring-blue-800"
            @click="save()"
          >
            {{ $gettext('Save') }}
          </button>
        </DialogPanel>
      </div>
    </Dialog>
  </TransitionRoot>
</template>

<script setup lang="ts">
  import { computed, inject, ref, watch } from 'vue'
  import { ServerConfig } from '../../../shared/server-config.model'
  import {
    TransitionRoot,
    Dialog,
    DialogPanel,
    DialogTitle,
    DialogDescription,
  } from '@headlessui/vue'
  import {
    RemoteInstanceBasic,
    UserInstanceData,
  } from '../../../shared/remote-instance'
  import {
    hostFromFederatedUsername,
    instanceNodeInfoMetadata,
    saveInstanceName,
    saveRedirectionURI,
  } from '@/plugins/preferredInstance'
  import { debounce } from 'lodash'

  const config = inject<ServerConfig>('config')
  const userInstance = inject<UserInstanceData>('userInstance')
  const updateUserInstance =
    inject<(newUserInstance: UserInstanceData) => void>('updateUserInstance')

  const indexName = computed(
    () => `<strong>${config.searchInstanceName}</strong>`
  )

  const hasDismissedSetupInstanceSuggestion = ref(
    localStorage?.getItem('hasDismissedSetupInstanceSuggestion') === 'true'
  )

  const showSuggestion = computed<boolean>(() => {
    return (
      !userInstance?.instanceName && !hasDismissedSetupInstanceSuggestion.value
    )
  })

  const dismissSuggestion = () => {
    hasDismissedSetupInstanceSuggestion.value = true
    localStorage?.setItem('hasDismissedSetupInstanceSuggestion', 'true')
  }

  const isOpen = ref(false)

  const setIsOpen = (value: boolean): void => {
    isOpen.value = value
  }

  const onInput = debounce(async (e: InputEvent) => {
    console.debug('e', (e.target as HTMLInputElement).value)
    federatedUsername.value = (e.target as HTMLInputElement).value
    const instanceData = await federatedIdentityToInstance(
      federatedUsername.value
    )
    instance.value = instanceData
  }, 500)

  const save = async () => {
    const instanceData = await federatedIdentityToInstance(
      federatedUsername.value
    )
    instance.value = instanceData
    const redirectionURI = await saveRedirectionURI(federatedUsername.value)
    saveInstanceName(instanceData.name)
    updateUserInstance({
      instanceName: instanceData.name,
      instanceRedirectURI: redirectionURI,
    })
    isOpen.value = false
  }

  const federatedUsername = ref('')
  const instance = ref<RemoteInstanceBasic>(null)

  watch(federatedUsername, async (identity) => {
    instance.value = await federatedIdentityToInstance(identity)
  })

  const federatedIdentityToInstance = async (
    identity: string
  ): Promise<RemoteInstanceBasic> => {
    return {
      ...(await instanceNodeInfoMetadata(identity)),
      host: hostFromFederatedUsername(identity),
    }
  }
</script>
